Feature('Mail Send')

Before(async ({ users }) => {
  await users.create() // Sender
  await users.create() // Recipient
})

After(async ({ users }) => { await users.removeAll() })

Scenario('Send and receive mail @smoketest', async ({ I, users, mail }) => {
  const [sender, recipient] = users

  await I.login('app=io.ox/mail', { user: sender })
  await mail.newMail()
  I.fillField(mail.to, recipient.get('primaryEmail'))
  I.fillField(mail.subject, 'Test mail')
  mail.send()
  await I.logout()

  await I.login('app=io.ox/mail', { user: recipient })

  let element = await I.grabNumberOfVisibleElements('.list-item.selectable')
  let retries = 6
  while (!element && retries) {
    retries--
    I.waitForNetworkTraffic()
    I.triggerRefresh()
    I.waitForNetworkTraffic()
    I.wait(10.5)
    element = await I.grabNumberOfVisibleElements('.list-item.selectable')
    if (!retries) assert.fail('Timeout waiting for element')
  }
  I.waitForText('Test mail')
})
