function sortDuration (a, b) {
  return a.duration < b.duration ? 1 : -1
}

module.exports = {
  partition (list, partitions) {
    const durations = list.map(t => t.duration || 10000)
    const maxDuration = durations.reduce((acc, duration) => Math.max(acc, duration), 0)
    const sumDuration = durations.reduce((acc, duration) => acc + duration, 0)
    const bucketSize = Math.max(sumDuration / partitions, maxDuration)
    let ix = 0
    return list.reduce(function (acc, t) {
      if (acc[ix].duration + (t.duration || 10000) > bucketSize) {
        ix = Math.min(ix + 1, partitions - 1)
        if (!acc[ix]) acc.push({ duration: 0, items: [] })
      }
      acc[ix].duration += (t.duration || 10000)
      acc[ix].items.push(t.fullTitle)
      acc.sort(sortDuration)
      return acc
    }, [{ duration: 0, items: [] }]).map(r => r.items).filter(r => r.length > 0)
  }
}
